//
//  LSRefresh.m
//  LSRefresh
//
//  Created by Felix Schwarz on 10.10.06.
//  Copyright 2006 IOSPIRIT GmbH, Felix Schwarz. All rights reserved.
//

#import "LSRefresh.h"

@implementation LSRefresh

- (void)awakeFromNib
{
	[self lsRefresh:nil];
}

- (IBAction)lsRefresh:(id)sender
{
	NSOpenPanel *openPanel;
	
	if (openPanel = [NSOpenPanel openPanel])
	{
		[openPanel setAllowsMultipleSelection:YES];
		[openPanel setResolvesAliases:YES];
		[openPanel setMessage:@"Select items to update in Launch Services database"];
		[openPanel setPrompt:@"Update"];
		
		if ([openPanel runModalForDirectory:@"/Applications" file:nil types:[NSArray arrayWithObject:@"app"]] == NSOKButton)
		{
			NSEnumerator *pathsEnum = [[openPanel filenames] objectEnumerator];
			NSString *path;
			UInt32 succ=0;
			NSAlert *alert;
			
			while (path = [pathsEnum nextObject])
			{
				NSURL *url;
				
				if (url = [NSURL fileURLWithPath:path])
				{
					OSStatus err;
				
					if (err = LSRegisterURL((CFURLRef)url,YES))
					{
						NSAlert *alert;
						
						alert = [NSAlert alertWithMessageText:@"Error updating database"
									defaultButton:@"OK"
								      alternateButton:nil
									  otherButton:nil
							    informativeTextWithFormat:@"LSRegisterURL returned error code %d when trying to update information of %@",
										      err,
										      path];
						[alert runModal];
					}
					else
					{
						succ++;
					}
				}
			};
						
			alert = [NSAlert alertWithMessageText:@"Update complete"
						defaultButton:@"OK"
					      alternateButton:@"Quit"
						  otherButton:nil
				    informativeTextWithFormat:@"Updated Launch Services information on %d items successfully.",
							      succ];

			if ([alert runModal] == NSAlertAlternateReturn)
			{
				[[NSApplication sharedApplication] terminate:self];
			}
		}
	}
}

- (IBAction)lsRefreshHelp:(id)sender
{
	NSURL *url = [NSURL URLWithString:@"http://developer.apple.com/documentation/Carbon/Conceptual/LaunchServicesConcepts/index.html?http://developer.apple.com/documentation/Carbon/Conceptual/LaunchServicesConcepts/LSCConcepts/chapter_2_section_5.html"];
	
	LSOpenCFURLRef((CFURLRef)url,NULL);
}

- (IBAction)visitWebsite:(id)sender
{
	NSURL *url = [NSURL URLWithString:@"http://www.iospirit.com/lsrefresh/"];

	LSOpenCFURLRef((CFURLRef)url,NULL);
}

@end
